/* Processed by ecpg (4.5.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "send.pgc"
/*
Nome Artefato/Programa..: send.pgc
Empresa.................: UFRN-SINFO Universidade Federal do Rio Grande do Norte  
Autor(es)...............: Emerson Hermann (emersonhermann@gmail.com) (emerson@nfo.ufrn.br) 
Data Inicio ............: 07/01/2010
Data Atual..............: 01/02/2010
Versao..................: 0.01
Compilador/Interpretador: Postgres(ecpg) 4.5.0 / (ecpg)4.4.0 / GNU (gcc) 4.3.3 / GNU(gcc)4.2.4 / GNU(gcc)3.3.4
Sistemas Operacionais...: Linux
SGBD....................: PostgreSql 8.0, 8.1, 8.2, 8.3, 8.4 
Kernel..................: testado (2.6.27-7) (2.6.21-5) (2.4.29 com lib krb5-1.4.2-i486.22ttw.tgz) 
Finalidade..............: Processar e enviar logs do postgres
OBS.....................: SQL Embedded
*/
#include <stdio.h>
#include <stdlib.h>
//#include <process.h> 	// ativar para plataforma Windows 
#include <memory.h>
#include <string.h>
#include <errno.h> 	// tratamento de erros  
#include <strings.h>
#include <sys/types.h> 	// necessario para o daemonInit
#include <sys/stat.h> 	// necessario para o daemonInit
#include <fcntl.h> 	// necessario para o daemonInit
#include <unistd.h> 	// necessario no Unix/Linux para a funcao sleep
#include <time.h> 	// funcoes time_t, time, gmtime, localtime



/* exec sql begin declare section */

  //const char databasename [140] = "tcp:postgresql://10.0.2.15/test";
 
  // Conexao localhost
       
 
      
      
   
  //struct varchar_var  { int len; char arr[14]; } codigo_volume;
    
   
   
  


#line 35 "send.pgc"
 const char databasename [ 140 ] = "tcp:postgresql://localhost:5432/test" ;
 
#line 37 "send.pgc"
 const char userx [ 10 ] = "postgres" ;
 
#line 38 "send.pgc"
 const char passx [ 10 ] = "postgres" ;
 
#line 39 "send.pgc"
 int id_pesagem ;
 
#line 41 "send.pgc"
 char codigo_volume [ 14 ] ;
 
#line 42 "send.pgc"
 float peso_bruto ;
 
#line 43 "send.pgc"
 long lCountDb ;
/* exec sql end declare section */
#line 46 "send.pgc"


/* Incluso da Estrutura p/Tratamento de Erros - SQLCA */

#line 1 "/usr/local/pgsql/include/sqlca.h"
#ifndef POSTGRES_SQLCA_H
#define POSTGRES_SQLCA_H

#ifndef PGDLLIMPORT
#if  defined(WIN32) || defined(__CYGWIN__)
#define PGDLLIMPORT __declspec (dllimport)
#else
#define PGDLLIMPORT
#endif   /* __CYGWIN__ */
#endif   /* PGDLLIMPORT */

#define SQLERRMC_LEN	150

#ifdef __cplusplus
extern		"C"
{
#endif

struct sqlca_t
{
	char		sqlcaid[8];
	long		sqlabc;
	long		sqlcode;
	struct
	{
		int			sqlerrml;
		char		sqlerrmc[SQLERRMC_LEN];
	}			sqlerrm;
	char		sqlerrp[8];
	long		sqlerrd[6];
	/* Element 0: empty						*/
	/* 1: OID of processed tuple if applicable			*/
	/* 2: number of rows processed				*/
	/* after an INSERT, UPDATE or				*/
	/* DELETE statement					*/
	/* 3: empty						*/
	/* 4: empty						*/
	/* 5: empty						*/
	char		sqlwarn[8];
	/* Element 0: set to 'W' if at least one other is 'W'	*/
	/* 1: if 'W' at least one character string		*/
	/* value was truncated when it was			*/
	/* stored into a host variable.				*/

	/*
	 * 2: if 'W' a (hopefully) non-fatal notice occurred
	 */	/* 3: empty */
	/* 4: empty						*/
	/* 5: empty						*/
	/* 6: empty						*/
	/* 7: empty						*/

	char		sqlstate[5];
};

struct sqlca_t *ECPGget_sqlca(void);

#ifndef POSTGRES_ECPG_INTERNAL
#define sqlca (*ECPGget_sqlca())
#endif

#ifdef __cplusplus
}
#endif

#endif

#line 49 "send.pgc"


long    error=0L;


long printMsgError (void);

/***********************************************************
 *  Function connectDataBase ==> Conecta ao DB Postgres  *
 ***********************************************************/
int connectDataBase(void)
{
  /* Conecta ao Database */

  { ECPGconnect(__LINE__, 0, databasename , userx , passx , "myconnect", 0); }
#line 63 "send.pgc"
 
  
  //EXEC SQL CONNECT TO "tcp:postgresql://10.0.2.15:5432/test" AS myconnect USER pgsql IDENTIFIED BY pgsql; 
  // Conexao localhost
  //EXEC SQL CONNECT TO :databasename ; 
  error = printMsgError();

  if (error) 
  {
    printf("\nSQL ERROR> Nao foi possivel conectar ao Postgres Server!\n");
    exit(1);
  }
  
}

/*************************************************************
 *Function disconnectDataBase ==> Desconecta do DB Postgres*
 *************************************************************/
void disconnectDataBase(void)
{
  long lRet;

  /* Desconecta do Database atualmente conectado  */
  /* exec sql whenever sqlerror  continue ; */
#line 86 "send.pgc"

  { ECPGdisconnect(__LINE__, "CURRENT");}
#line 87 "send.pgc"

  printf ("SQL> Desconectando o Postgres...\n");

  if (SQLCODE)
  {
    printf("\nSQL> Detectado Erro na Desconexao no Postgres!\n");
    lRet = printMsgError();
    { ECPGtrans(__LINE__, NULL, "rollback");}
#line 94 "send.pgc"

    exit (0);
  }

  printf ("SQL> Desconexao do Postgres Realizada com Sucesso!\n");
  exit(1);

}

/***************************************************************
 *  Function PrintMsgError ==> Imprime uma Mensagem de Erro    *
 *                             refletindo o SQLCODE retornado  *
 *			       pelo Postgres                 *
 ***************************************************************/
long printMsgError (void)
{
  if (SQLCODE)
  {
    printf ("\nSQL ERROR> Postgres Error Code = %d.\n", SQLCODE);
  }
  return (SQLCODE);
}

/***************************************************************
 *  Function execExport ==> SELECT *                           * 
 *                            FROM ddl                         *
 *                           WHERE exportado IS FALSE          *
 ***************************************************************/
int execExport (void)
{

  int        iFd;  		// ponteiro do arquivo de importacao (Unix/Linux)
  char       szBuffer[300]; 	// para armazenar strings de comandos dml no arquivo de importacao
  long       i; 		// controle de loop
  time_t     stHora_sist; 	// Para armazenar a data hora do sistema em quantidade de segundos 
  struct tm  *ST_Hora_exp; 	// Para armazenar o formato expandido da data 


  /*
    Para ver se existem tuplas nao exportados
  */
  { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select count ( * ) from ddl", ECPGt_EOIT, 
	ECPGt_long,&(lCountDb),(long)1,(long)1,sizeof(long), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 137 "send.pgc"



  /* Declara um cursor para execucao da query.
   * Selecao de registros que nao foram exportados 
   */
  /* declare cs_tb cursor for select banco , usuario , maquina , data_hora , log from ddl order by data_hora */
#line 150 "send.pgc"


  
  /* Abre o cursor */
  { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare cs_tb cursor for select banco , usuario , maquina , data_hora , log from ddl order by data_hora", ECPGt_EOIT, ECPGt_EORT);}
#line 154 "send.pgc"

  

  /* Atualiza registro(s) exportado(s) FALSE para TRUE.
   * Garantia que o(s) registro(s) ora transacionados
   * nao serao exportados novamente
   */

  
  { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update ddl set exportado = true where exportado is false", ECPGt_EOIT, ECPGt_EORT);}
#line 166 "send.pgc"

  
  

  /* So por seguranca, para evitar gasto de processamento 
   * caso ocorra algum erro no processamento da(s) query(s)
   * evitando perder tempo com algo com problemas - desativado
   */
  /* 
  if (SQLCODE)
  {
    printMsgError();
    return (0);
  }
  */

  /* Caso a transacao seja efetuada sem 
   * problemas, sera efetuado um COMMIT e
   * geracao de arquivo de exportacao,
   * caso contrario sera efetuado ROLLBACK
   */
  

  if (SQLCODE = printMsgError())
  {
    { ECPGtrans(__LINE__, NULL, "rollback");}
#line 191 "send.pgc"

    printf ("SQL ERROR> Erro na Executacao da Query...\n");
  }
  else 
  {
    // Testa se veio alguma coisa do banco 
    if (lCountDb != 0)
    {
      /* Obtendo a data e hora atual do sistema 
       * Para configurar timezone no Unix/Linux: 
       * export TZ="Brazil/East"
       * Para configurar timezone no Windows:
       * set TZ=GMT-3
       */
      stHora_sist = time(NULL); // total em segundos
      ST_Hora_exp = localtime (&stHora_sist); // obtendo a data expandida considerando o timezone      

      /* criando arquivo de importacao */
      sprintf (szBuffer, "/tmp/lgsql_%02d_%02d_%04d_%02d_%02d_%02d.sql",ST_Hora_exp->tm_mday,ST_Hora_exp->tm_mon+1,(ST_Hora_exp->tm_year-100)+2000,ST_Hora_exp->tm_hour,ST_Hora_exp->tm_min,ST_Hora_exp->tm_sec);

      /* Abre arquivo com a devida permissao no SO */
      iFd = open (szBuffer, O_CREAT | O_WRONLY, 0400);

      /* Abrindo transacao no arquivo a ser importado  */

      sprintf(szBuffer, "--PID %d\nCOMMIT;\nSET TRANSACTION READ WRITE ISOLATION LEVEL READ COMMITTED NAME 'lg_sql_transaction_import'\n\n",getpid());

      write(iFd, szBuffer, strlen (szBuffer)); 

      /* Variavel de controle de loop*/
      i=1;
      do 
      {

	/* Execucao do fetch no curso aberto anteriormente */      
        { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch next from cs_tb", ECPGt_EOIT, 
	ECPGt_int,&(id_pesagem),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(codigo_volume),(long)14,(long)1,(14)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_float,&(peso_bruto),(long)1,(long)1,sizeof(float), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 226 "send.pgc"


	//printf("INFO> Registro Id: %d - %14s - %14.2f\n",id_pesagem, codigo_volume, peso_bruto);

        sprintf(szBuffer, "INSERT INTO sd3010 (D3_FILIAL, D3_TM, D3_COD, D3_UM, D3_QUANT, D3_PESOB, D3_TARA, D3_VOL, D3_HORA) \
		       	VALUES (%d,%14s,%7.2f);\n\n",id_pesagem,codigo_volume, peso_bruto);
        write(iFd, szBuffer, strlen (szBuffer)); 
	i++;

      }  
      while (i<=lCountDb);
     

      /* Efetuando COMMIT no arquivo a ser importado  */

      sprintf(szBuffer, "COMMIT;\nQUIT;\n");
      write(iFd, szBuffer, strlen (szBuffer)); 

      /* Fechando o arquivo, uma boa pratica */
      close(iFd);
 

    }
    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close cs_tb", ECPGt_EOIT, ECPGt_EORT);}
#line 249 "send.pgc"


    { ECPGtrans(__LINE__, NULL, "commit");}
#line 251 "send.pgc"


    //printf ("INFO> Registro(s) processado(s)!\n");

  }

  return (0);
  
}
/***************************************************************
 *  Function daemonInit ==> Funcao para tramsformar processo   *
 *                           terminal em processo daemon       *
 *                           (Linux / Unix)                    *
 ***************************************************************/
int daemonInit (void)
{
  pid_t     iPid;
  long      iMaxFd;
  int       i;

  /* 1o. Passo - Duplica o processo usando fork. 
   * O processo pai eh encerrado.
   */

  if ((iPid = fork()) < 0)
    return -1;

  if (iPid != 0)
    exit(0);


  /* 2o. Passo - Chama a funcao setsid para criar uma nova sessao de processo, 
   * ficando o processo filho como lider da sessao e sem um terminal de controle 
   * associado ao processo 
   */

  setsid();

  /* 3o. Passo - Mudando para o diretorio raiz (root) ou para o diretorio 
   * proprio do daemon 
   */

  chdir ("/");

  /* 4o. Passo - Inicializa a mascara padrao de criacao (permissao) de arquivos  
   */

  umask (0);

  /* 5o. Passo - Fechando todos descritores existentes no sistema. Utiliza-se a informacao
   * de numero maximo de descritores configurado no sistema, obtido com a funcao sysconf.
   * Para outras opcoes da funcao sysconf, favor verificar o manual on-line do sistema
   */

  iMaxFd = sysconf (_SC_OPEN_MAX);
  for (i=0; i < iMaxFd; i++)
  {
    close (i);
  }

  return 0;
}


#if defined(UNIX) || defined(WINNT)
  void sighandler(sig)
  int sig;
  {
    disconnectDataBase ();
    exit(0);
  }
#endif


/*******************
 *  FUNCTION MAIN  *
 *******************/
int main (int argc, char *argv[])
{

  system("clear");
  printf ("**************************************************************\n");
  printf ("**         pgLogger - Processa logs do Postgres             **\n");
  printf ("**                   send - Versao 0.1                      **\n");  
  printf ("** -                 Desenvolvido por:                    - **\n"); 
  printf ("** - Emerson Hermann - Email: (emersonhermann@gmail.com)  - **\n"); 
  printf ("**                       Agradecimentos                     **\n"); 
  printf ("**                 Obrigado JESUS por tudo !!!!             **\n"); 
  printf ("**************************************************************\n\n");

  /* Adaptacoes futuras para Windows / Linux / Unix */

  #if defined(UNIX) || defined(WINNT)
    signal(SIGINT,(void (__cdecl *) (int))sighandler);
    signal(SIGTERM,(void (__cdecl *) (int))sighandler);
    signal(SIGSEGV,(void (__cdecl *) (int))sighandler);
  #ifndef UNIX
    signal(SIGQUIT,sighandler);
    signal(SIGBUS,sighandler);
    signal(SIGHUP,sighandler);
  #endif
  #endif

  /* Aqui faz a brincadeira de rodar em daemon */  


  if (daemonInit () < 0) 
  {
    perror (argv[0]);  	  
    exit (errno);		
  }
 

  
  /* Conectar ao Postgres */
  connectDataBase();

  /* Apenas para tratar o erro do SQL, continuar rodando caso encontre erro */
  /* exec sql whenever sqlerror  continue ; */
#line 369 "send.pgc"


  while (1)
  {

	  
    // Processo de execucao da exportacao, geracao de querys e arquivos 	
    execExport();

    // Delay, tempo de intervalo de execucao em segundos 
    sleep(3);

    /* Apenas um teste */

    system("cat /proc/ide/hda/model >> /tmp/test.txt");


  }

  exit (0);

  /* Este artefato rodara eternamente em processo daemon (function daemonInit), 
   * nao sendo necessario fechar conexao, mas por precaucao caso seja dado um  
   * kill no processo, havera uma tentativa de fechamento da conexao
   * com o banco, muito embora ja exista algo para tratamento desta situacao. 
   */

  disconnectDataBase ();
}

